﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;
using Infragistics.Win.UltraWinToolbars;

namespace EmbossRibbonTab
{
    class MyDrawFilter : IUIElementDrawFilter
    {
        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            bool isDrawn = false;
            if (drawParams.Element.Parent is RibbonTabItemUIElement)
            {
                isDrawn = true;
                ImageAndTextUIElement.ImageAndTextDependentTextUIElement element =
                    drawParams.Element as ImageAndTextUIElement.ImageAndTextDependentTextUIElement;
                string strText = element.Text;

                int iOffset = 1;
                
                //Rectangle rect = new Rectangle(element.Rect.X, element.Rect.Y, element.Rect.Width, element.Rect.Height);
                int x = element.Rect.X + 5;
                int y = element.Rect.Y;
                for (int i = iOffset; i >= 0; i--)
                {
                    x -= 1;
                    y += 1;
                    // drawParams.Font gives us the Font properties used by this element
                    drawParams.Graphics.DrawString(strText, drawParams.Font, Brushes.Gray, x, y);
                }
                // Now draw the black portion of text
                drawParams.Graphics.DrawString(strText, drawParams.Font, Brushes.Black, element.Rect.X + 5, element.Rect.Y);
            }
            return isDrawn;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            return drawParams.Element is ImageAndTextUIElement.ImageAndTextDependentTextUIElement ? DrawPhase.BeforeDrawForeground : DrawPhase.None;
        }

        #endregion
    }
}
